import * as react_jsx_runtime from 'react/jsx-runtime';
import React from 'react';

interface CodeSpotlightContextType {
    ref: React.RefObject<HTMLPreElement> | null;
    id: string;
    mode: CodeSpotlightMode;
}
type CodeSpotlightMode = "equal" | "include";
declare function useCodeSpotlightContext(): CodeSpotlightContextType;
declare function CodeSpotlight({ children, mode, }: {
    children: React.ReactNode;
    mode?: CodeSpotlightMode;
}): react_jsx_runtime.JSX.Element;
declare namespace CodeSpotlight {
    var Trigger: typeof CodeSpotlightTrigger;
}
declare function CodeSpotlightTrigger({ children, target, }: {
    children: React.ReactNode;
    target: string;
}): react_jsx_runtime.JSX.Element;

declare const useCodeSpotlight: () => {
    id: string;
    focusTarget: (target: string) => void;
    unfocusTarget: () => void;
};

export { CodeSpotlight, type CodeSpotlightMode, CodeSpotlightTrigger, useCodeSpotlight, useCodeSpotlightContext };
