"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var index_exports = {};
__export(index_exports, {
  CodeSpotlight: () => CodeSpotlight,
  CodeSpotlightTrigger: () => CodeSpotlightTrigger,
  useCodeSpotlight: () => useCodeSpotlight,
  useCodeSpotlightContext: () => useCodeSpotlightContext
});
module.exports = __toCommonJS(index_exports);

// src/components.tsx
var import_react = __toESM(require("react"));

// src/useCodeSpotlight.ts
var useCodeSpotlight = () => {
  const { id, mode, ref } = useCodeSpotlightContext();
  const focusTarget = (target) => {
    const codeBlock = ref?.current;
    if (!codeBlock) return;
    codeBlock.setAttribute("data-hovered", "true");
    const tokens = codeBlock.querySelectorAll("span");
    tokens.forEach((token) => {
      if (mode === "equal" && token.textContent === target) {
        token.classList.add("spotlight-target");
      } else if (mode === "include" && token.textContent?.includes(target)) {
        token.classList.add("spotlight-target");
      } else {
        token.classList.remove("spotlight-target");
      }
    });
  };
  const unfocusTarget = () => {
    const codeBlock = ref?.current;
    if (!codeBlock) return;
    codeBlock.setAttribute("data-hovered", "false");
    const tokens = codeBlock.querySelectorAll("span");
    tokens.forEach((token) => {
      token.classList.remove("spotlight-target");
    });
  };
  return { id, focusTarget, unfocusTarget };
};

// src/components.tsx
var import_jsx_runtime = require("react/jsx-runtime");
var CodeSpotlightContext = (0, import_react.createContext)({
  ref: null,
  id: "",
  mode: "equal"
});
function useCodeSpotlightContext() {
  const context = (0, import_react.useContext)(CodeSpotlightContext);
  if (!context) {
    console.error(
      "[code-spotlight] useCodeSpotlight must be used within a CodeSpotlightProvider"
    );
  }
  return context;
}
function CodeSpotlight({
  children,
  mode = "include"
}) {
  const preRef = (0, import_react.useRef)(null);
  const id = (0, import_react.useId)();
  const value = (0, import_react.useMemo)(() => ({ id, mode, ref: preRef }), [id, mode, preRef]);
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(CodeSpotlightContext.Provider, { value, children: import_react.default.Children.map(children, (child) => {
    if (typeof child === "object" && child !== null && "type" in child && child.type === "pre") {
      return import_react.default.cloneElement(child, {
        id,
        className: child.props && typeof child.props === "object" && "className" in child.props ? `${child.props.className} code-spotlight-container` : "code-spotlight-container",
        ref: preRef
      });
    }
    return child;
  }) });
}
function CodeSpotlightTrigger({
  children,
  target
}) {
  const { focusTarget, unfocusTarget } = useCodeSpotlight();
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
    "code",
    {
      className: "code-spotlight-trigger",
      onMouseEnter: () => focusTarget(target),
      onMouseLeave: unfocusTarget,
      children
    }
  );
}
CodeSpotlight.Trigger = CodeSpotlightTrigger;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  CodeSpotlight,
  CodeSpotlightTrigger,
  useCodeSpotlight,
  useCodeSpotlightContext
});
